## How to contribute to the Arduino Joystick Library

### Report a bug

* **Check to see if the bug has already reported** by searching on GitHub under [Issues](https://github.com/MHeironimus/ArduinoJoystickLibrary/issues).

* If you're unable to find an open issue addressing the problem, [open a new one](https://github.com/MHeironimus/ArduinoJoystickLibrary/issues/new). Be sure to include a **title and clear description**, as much relevant information as possible (e.g. host OS, Arduino IDE version, etc.), any important hardware information (e.g. name of Arduino board being used, specific pin wirings if they are relavant, etc.), and a **sample sketch** file demonstrating the issue.

### Fix a bug

* Open a new GitHub pull request with the fix.

* Ensure the PR description clearly describes the problem and solution. Include the relevant issue number if applicable.

### Whitespace, format code, or cosmetic updates

* Changes that are cosmetic in nature and do not add anything substantial to the stability, functionality, or testability will generally not be accepted.

### Adding a new feature

* Feel free to [create a new issue](https://github.com/MHeironimus/ArduinoJoystickLibrary/issues/new) to document the feature you are planning to add. This will allow others to see and comment on what you would plan to add to the library.

### Questions about the library

* Be sure to check the [FAQ](https://github.com/MHeironimus/ArduinoJoystickLibrary/wiki/FAQ) in the [Wiki](https://github.com/MHeironimus/ArduinoJoystickLibrary/wiki) to see if your question has already been answered.
* Another good place to look for general Arduino questions is the [Arduino]() website.

The Arduino Joystick Library is a volunteer effort done in volunteer's spare time. Please be patient as it may take some time for bugs to be fixed, features to be added, and questions to be answered.
